# 
#  Copyright (C) 2019  Smithsonian Astrophysical Observatory
#
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#


import os
import subprocess
import atexit 

plot_list=[]


def add_curve(fname, overplot=1, **kwargs):
    if len(plot_list) > 0:
        kk = kwargs.__str__()
        kk += ("\n")
        plot_list[-1].stdin.write(kk)


def add_histogram(fname, overplot=1, **kwargs):
    if len(plot_list) > 0:
        kk = kwargs.__str__()
        kk += ("\n")
        plot_list[-1].stdin.write(kk)


def cleanup_plots():
    for pp in plot_list:
        pp.stdin.write("quit")
        pp.kill()
    plot_list.clear()

# create the subprocess- need location of handler script
mwrap = os.path.dirname(__file__) + "/matplot_wrap_handler.py"
xx = subprocess.Popen(["python", mwrap], stdin=subprocess.PIPE,bufsize=1,universal_newlines=True)
plot_list.append(xx)
atexit.register(cleanup_plots)

